#include "stdafx.h"
#include "NeMessenger.h"
#include "DialInfoWnd.h"
#include "AnimImage.h"

#define ID_DIAL_INFO_BS_BTN	(0xA018)


IMPLEMENT_DYNAMIC(CDialInfoWnd, CWnd)

CDialInfoWnd::CDialInfoWnd()
{
	m_pImgBg = NULL;
	m_pImgTalk = NULL;
	m_strPhoneNumber = _T("");
	m_strShowPhoneNumber = _T("");
	m_eCallStatus = iptstIDLE;
	m_strCurrentStatus = _T("");
	m_pGIFConnecting = NULL;
	m_rtConnecting.SetRectEmpty();
	m_rtPhoneNumber.SetRect(10, 33, 148, 50);

	ClearMemberData();
}

CDialInfoWnd::~CDialInfoWnd()
{
	SAFE_DELETE(m_pImgBg);
	SAFE_DELETE(m_pImgTalk);
	SAFE_DELETE(m_pGIFConnecting);
}


BEGIN_MESSAGE_MAP(CDialInfoWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_BN_CLICKED(ID_DIAL_INFO_BS_BTN, &CDialInfoWnd::OnBnClickedBackspace)
END_MESSAGE_MAP()


int CDialInfoWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_pImgBg = new Image(GetAppImgFile(_T("IPT_display_bg.png")));
	m_pImgTalk = new Image(GetAppImgFile(_T("IPT_dial_talk.png")));

	m_btnBackspace.Create(_T(""), WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | BS_OWNERDRAW, CRect(171, 35, 80, 13), this, ID_DIAL_INFO_BS_BTN);
	m_btnBackspace.SetBtnBitmapFile(GetAppImgFile(_T("IPT_backspace.bmp")), RGB(255,0,255));
	m_rtConnecting.SetRect(10, 53, 10 + 18, 53 + 18);

	return 0;
}

BOOL CDialInfoWnd::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CDialInfoWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	PAINTSTRUCT ps = dc.m_ps; //Ŭ̾Ʈ  ׸  PAINSTRUCT
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);

	HDC hdc = dc.GetSafeHdc();
	HDC hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory, hbmpMem);
	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		if (m_pImgBg)
		{
			DrawImageToDest(&graph, m_pImgBg, &rtPS, &rt, &ImgAttr);
		}
		else
		{
			SolidBrush brushBG(Color(255,180,180,180));			
			Pen penBG(Color(255,180,180,180), 1);
			graph.FillRectangle(&brushBG, nPX, nPY, psWidth, psHeight);
			graph.DrawRectangle(&penBG, nPX, nPY, psWidth, psHeight);
		}

		CRect rtLine(8, 13, rt.right - 5, 13 + 17);

		// ù° -  
		if (!m_userData.strName.empty())
		{
			REAL nFontHeight = 9;
			CString strUserInfo;
			strUserInfo.Format(_T("%s "), m_userData.strName.c_str());
			DrawTextToDest2(&graph, strUserInfo, &rtPS, &(rtLine), g_defaultFontFaceName, nFontHeight, StringAlignmentNear, FontStyleBold, Color(255,34,34,34));

			CSize szName(0, 0);
			RecalcTextRect(this, strUserInfo, g_defaultFontFaceName, nFontHeight, FontStyleBold, rtLine, szName);
			rtLine.left += szName.cx;
			rtLine.top += 2;
			strUserInfo.Format(_T("[%s/%s]%s"), m_userData.strJobPos.c_str(), m_userData.strJobDuty.c_str(), m_userData.strDept.c_str());
			DrawTextToDest2(&graph, strUserInfo, &rtPS, &(rtLine), g_defaultFontFaceName, (REAL)8, StringAlignmentNear, FontStyleRegular, Color(255,136,136,136));

			rtLine.left -= szName.cx;
			rtLine.top -= 2;
		}

		// ° - ȭȣ
		DrawTextToDest2(&graph, m_strShowPhoneNumber, &rtPS, &(m_rtPhoneNumber), g_defaultFontFaceName, 10, StringAlignmentNear, FontStyleBold, Color(255,0,138,255));

		if (m_eCallStatus == iptstACTIVE && m_pImgTalk)
		{
			CRect rtTalk(10, 53, 10 + 18, 53 + 18);
			DrawImageToDest(&graph, m_pImgTalk, &rtPS, &(rtTalk), &ImgAttr);
		}

		// ° -  
		rtLine.OffsetRect(23, 40);	//   ڸŭ Shift
		rtLine.right -= 23;			//  ũ⸸ŭ ٿش.
		DrawTextToDest2(&graph, m_strCurrentStatus, &rtPS, &(rtLine), g_defaultFontFaceName, 9, StringAlignmentNear, FontStyleRegular, Color(255,136,136,136));

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CDialInfoWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);
}

void CDialInfoWnd::SetMemberData( NE_MEMBER_DATA memberData )
{
	m_userData = memberData;
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
}

void CDialInfoWnd::OnBnClickedBackspace()
{
	if (m_strPhoneNumber.IsEmpty())
		return;

	int nNumberLen = m_strPhoneNumber.GetLength();
	m_strPhoneNumber = m_strPhoneNumber.Left(nNumberLen - 1);
	m_strShowPhoneNumber = GetShowPhoneNumber(m_strPhoneNumber);

	ClearMemberData();
	RedrawWindow(&m_rtPhoneNumber, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
}

void CDialInfoWnd::AddNumber(TCHAR chNum)
{
	m_strPhoneNumber.AppendChar(chNum);
	m_strShowPhoneNumber = GetShowPhoneNumber(m_strPhoneNumber);

	ClearMemberData();
	RedrawWindow(&m_rtPhoneNumber, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
}

void CDialInfoWnd::SetCallStatus(NTIPTStatusType cst)
{
	m_eCallStatus = cst;
	
	switch (m_eCallStatus)
	{
	case itpstALERTING:
		m_strCurrentStatus = LoadStringFromResource(IDS_CHAT_INVITESTATUS_MSG);
		ShowConnectingGIF();
		break;

	case iptstACTIVE:
		m_strCurrentStatus = LoadStringFromResource(IDS_STRING135);
		DeleteConnectingGIF();
		break;

	default:
		m_strCurrentStatus = _T("");
		DeleteConnectingGIF();
		break;
	}

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
}

void CDialInfoWnd::DeleteConnectingGIF()
{
	if (m_pGIFConnecting)
	{
		delete m_pGIFConnecting;
		m_pGIFConnecting = NULL;

		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW /*| RDW_ERASE*/);
	}
}

void CDialInfoWnd::ShowConnectingGIF()
{
	if (m_pGIFConnecting)
		DeleteConnectingGIF();

	m_pGIFConnecting = new CAnimImage(_T("GIF"), _T("IPT_CALLING"));

	if (m_pGIFConnecting)
	{
		int nCX = 10;
		int nCY = 53;

		m_pGIFConnecting->InitAnimation(m_hWnd, CPoint(nCX, nCY));
	}
}

void CDialInfoWnd::SetCallNumber(CString strNumber)
{
	m_strPhoneNumber = strNumber;
	m_strShowPhoneNumber = GetShowPhoneNumber(m_strPhoneNumber);
	RedrawWindow(&m_rtPhoneNumber, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
}

CString CDialInfoWnd::GetShowPhoneNumber(CString strPhoneNumber)
{
	CString strShowPhoneNumber = strPhoneNumber;
	CSize szNumber(0, 0);
	REAL nFontHeight = 10;
	RecalcTextRect(this, strPhoneNumber, g_defaultFontFaceName, nFontHeight, FontStyleBold, m_rtPhoneNumber, szNumber);

	int nCnt = 1;
	int nLen = strPhoneNumber.GetLength();
	
	while (szNumber.cx > m_rtPhoneNumber.Width() && nCnt < nLen)
	{
		nFontHeight = 10;
		nLen = strPhoneNumber.GetLength();
		strShowPhoneNumber.Format(_T("...%s"), strPhoneNumber.Mid(nCnt, nLen - nCnt));
		RecalcTextRect(this, strShowPhoneNumber, g_defaultFontFaceName, nFontHeight, FontStyleBold, m_rtPhoneNumber, szNumber);
		nCnt++;
	}

	return strShowPhoneNumber;
}

void CDialInfoWnd::ClearMemberData()
{
	m_userData.strUserId = L"";
	m_userData.strName = L"";
	m_userData.strNameUS = L"";
	m_userData.strNameKR = L"";
	m_userData.strNameTW = L"";
	m_userData.strNameJP = L"";
	m_userData.strNameCN = L"";
	m_userData.strDept = L"";
	m_userData.strDeptId = L"";
	m_userData.strJobPos = L"";
	m_userData.strJobPosCd = L"";
	m_userData.strJobDuty = L"";
	m_userData.strJobDutyCd = L"";
	m_userData.strIncoTel = L"";
	m_userData.strExtesion = L"";
	m_userData.strCellPhone = L"";
}
